var l = Object.defineProperty;
var p = (o, s, t) => s in o ? l(o, s, { enumerable: !0, configurable: !0, writable: !0, value: t }) : o[s] = t;
var e = (o, s, t) => (p(o, typeof s != "symbol" ? s + "" : s, t), t);
import { autoUpdate as u, computePosition as c, shift as m, flip as v } from "@floating-ui/dom";
import { hello as b, goodbye as f } from "hello-goodbye";
const r = class extends HTMLElement {
  constructor() {
    super(...arguments);
    e(this, "parent");
    e(this, "tooltip");
    e(this, "timeout");
    e(this, "disabledObserver");
    e(this, "showing", !1);
    e(this, "cleanup");
    e(this, "prevInnerHTML");
    e(this, "onMouseEnter", this.afterDelay.bind(this, this.show));
    e(this, "onFocus", this.show.bind(this));
    e(this, "onMouseLeave", this.afterDelay.bind(this, this.hide));
    e(this, "onBlur", this.hide.bind(this));
    e(this, "onPointerUp", (t) => {
      t.pointerType === "mouse" ? this.hide() : this.show();
    });
    e(this, "onKeyDown", (t) => {
      t.key === "Escape" && this.hide();
    });
  }
  connectedCallback() {
    this.parent = this.parentNode, this.parent && (this.parent.addEventListener("mouseenter", this.onMouseEnter), this.parent.addEventListener("focus", this.onFocus), this.parent.addEventListener("mouseleave", this.onMouseLeave), this.parent.addEventListener("blur", this.onBlur), this.parent.addEventListener("pointerup", this.onPointerUp), this.disabledObserver = new MutationObserver((t) => {
      t.forEach((i) => {
        i.attributeName === "disabled" && this.hide();
      });
    }), this.disabledObserver.observe(this.parent, { attributes: !0 })), document.addEventListener("keydown", this.onKeyDown), document.addEventListener("scroll", this.onBlur);
  }
  disconnectedCallback() {
    var t, i;
    (t = this.cleanup) == null || t.call(this), this.tooltip && (this.tooltip.remove(), this.tooltip = void 0), this.parent && (this.parent.removeEventListener("mouseenter", this.onMouseEnter), this.parent.removeEventListener("focus", this.onFocus), this.parent.removeEventListener("mouseleave", this.onMouseLeave), this.parent.removeEventListener("blur", this.onBlur), this.parent.removeEventListener("pointerup", this.onPointerUp), this.parent = void 0), document.removeEventListener("keydown", this.onKeyDown), document.removeEventListener("scroll", this.onBlur), (i = this.disabledObserver) == null || i.disconnect(), clearTimeout(this.timeout);
  }
  get disabled() {
    return this.hasAttribute("disabled");
  }
  set disabled(t) {
    t ? this.setAttribute("disabled", "") : this.removeAttribute("disabled");
  }
  show() {
    var i;
    if (this.disabled)
      return;
    const t = this.createTooltip();
    clearTimeout(this.timeout), this.showing || (t.hidden = !1, b(t), this.showing = !0), this.innerHTML !== this.prevInnerHTML && (this.prevInnerHTML = t.innerHTML = this.innerHTML), t.style.position = "absolute", (i = this.cleanup) == null || i.call(this), this.cleanup = u(
      this.parent,
      t,
      () => c(this.parent, t, {
        placement: this.getAttribute("placement") || r.placement,
        middleware: [m(), v()]
      }).then(({ x: h, y: a, placement: d }) => {
        Object.assign(t.style, {
          left: `${h}px`,
          top: `${a}px`
        }), t.dataset.placement = d;
      })
    );
  }
  hide() {
    var t;
    clearTimeout(this.timeout), (t = this.cleanup) == null || t.call(this), this.showing && (this.showing = !1, f(this.tooltip).then(() => {
      this.tooltip && (this.tooltip.hidden = !0);
    }));
  }
  afterDelay(t) {
    clearTimeout(this.timeout);
    const i = parseInt(this.getAttribute("delay") || "");
    this.timeout = window.setTimeout(
      t.bind(this),
      isNaN(i) ? r.delay : i
    );
  }
  createTooltip() {
    return this.tooltip || (this.tooltip = document.createElement("div"), this.tooltip.className = this.getAttribute("tooltip-class") || r.tooltipClass, this.tooltip.hidden = !0, this.tooltip.addEventListener("mouseenter", this.show.bind(this)), this.tooltip.addEventListener(
      "mouseleave",
      this.afterDelay.bind(this, this.hide)
    ), document.body.appendChild(this.tooltip)), this.tooltip;
  }
};
let n = r;
e(n, "delay", 100), e(n, "placement", "top"), e(n, "tooltipClass", "tooltip");
export {
  n as default
};
